3 paths=(/home/pub/video/anime $HOME/dc/autodl/cur)
7 if [ -r badlist ]; then
8 echo badlist `head -n 1 curep`
13 if [ "`cat curep`" -le "`cat maxep`" ]; then
14 echo curep `cat curep`
17 echo curep `cat curep`
33 if [ "${epinfo[0]}" = none ]; then
34 echo "no available episode of $tag" >&2
35 echo "$tag" >>"$HOME/dc/autodl/faulty"
42 if [ -r badsizes ]; then
43 badsizesl="$(sed -n "s/^0*$curep \([^#]*\)\( *#.*\)\?$/\1/p" badsizes)"
45 if [ -n "$badsizesl" ]; then
46 read -a badsizes <<<"$badsizesl"
48 echo "found bad size list: ${badsizes[@]}"
51 fsexpr="`printf "$sexpr" "$curep"`"
52 if [ "${#badsizes[@]}" -gt 0 ]; then
53 for badsize in "${badsizes[@]}"; do
54 fsexpr="$fsexpr & ! S=$badsize"
59 args=(-e "$fsexpr" -t "$tag $curep" -I "$infofile" -E "$estatfile" -x "curep=$curep")
61 args=("${args[@]}" -w)
65 elif [ -e autouarg ]; then
66 uarg="rename:$tag - %02i.ext:move:../autodl/cur/$tag"
68 if [ -n "$uarg" ]; then
69 fuarg="`printf "$uarg" "$curep"`"
70 args=("${args[@]}" -a "$fuarg")
73 echo "trying to download -- autodl ${args[@]}"
75 autodl "${args[@]}" >"$outfile" 2>&1 &
77 trap "intr=y; kill -INT $pid" USR1 INT
80 if [ -r "$estatfile" ]; then
81 estat="`cat "$estatfile"`"
84 if [ "$intr" = y ]; then
85 echo "$tag interrupted"
87 if [ "$stat" -ne 0 ]; then
88 if [ "$stat" -eq 1 ]; then
89 echo "Failure for $tag" >>"$HOME/dc/autodl/errorlog"
90 tail -n 20 "$outfile" >>"$HOME/dc/autodl/errorlog"
91 elif [ "$stat" -eq 2 ]; then
92 echo "Connection error on $tag"
93 elif [ "$stat" -eq 3 ]; then
94 echo "Configuration error, disabling $tag"
97 echo "$tag" >>"$HOME/dc/autodl/faulty"
100 echo "episode $curep of $tag done (estat: \"$estat\")"
103 echo -en "${tag}\n${curep}\n" >>"$HOME/dc/autodl/baddone"
104 egrep -v "^$curep( |\$)" badlist >newbadlist
105 mv -f newbadlist badlist
106 if [ `wc -l <badlist` -eq 0 ]; then
108 echo "$tag has no more bad episodes"
109 echo "$tag" >>"$HOME/dc/autodl/badmaxed"
113 if [ "$estat" = dbl ]; then
114 echo -en "${tag}\n${curep}\n" >>"$HOME/dc/autodl/done"
115 echo -en "${tag}\n$((${curep} + 1))\n" >>"$HOME/dc/autodl/done"
118 echo -en "${tag}\n${curep}\n" >>"$HOME/dc/autodl/done"
122 if [ -r maxep ]; then
123 if [ "$curep" -gt "`cat maxep`" ]; then
124 echo "$tag has reached max"
125 echo "$tag" >>"$HOME/dc/autodl/maxed"
131 echo "no more episodes to download from $tag"
137 rm -f "$HOME/dc/autodl/run/$tag"
140 for dir in $HOME/dc/autodl{,/cur,/run}; do
141 if [ -e "$dir" ]; then
142 if [ ! -d "$dir" ]; then
143 echo "$dir is not a directory, please remedy and restart" >&2
147 mkdir "$dir" || exit 1
151 while [ $# -gt 0 ]; do
156 pid="$(cat "$HOME/dc/autodl/run/master")"
157 if [ -z "$pid" ]; then
158 echo "autodlctl: could not read a PID from $HOME/dc/autodl/run/master" >&2
165 echo "autodlctl: unrecognized option: \"$arg\"" >&2
173 trap "done=y" INT QUIT TERM
174 echo $$ >"$HOME/dc/autodl/run/master"
175 while [ "$done" != y ]; do
176 for pidfile in $HOME/dc/autodl/run/*; do
177 if [ "$pidfile" = "$HOME/dc/autodl/run/*" ]; then break; fi
178 pid="`cat "$pidfile"`"
179 if [ -d /proc/1 -a ! -d "/proc/$pid" ]; then
180 echo "removing stale pidfile $pidfile"
184 for p in "${paths[@]}"; do
186 if [ -d "$d/.autodl" -a ! -e "$d/.autodl/disabled" ]; then
187 if [ -r "$d/.autodl/tag" ]; then
188 tag="`cat "$d/.autodl/tag"`"
190 tag="`basename "$d"`"
193 if [ -e "$d/.autodl/disable" ]; then
194 echo "disabling $tag per user request"
196 touch "$d/.autodl/disabled"
197 rm -f "$d/.autodl/disable"
198 if [ -r "$HOME/dc/autodl/run/$tag" ]; then
199 pid="`cat "$HOME/dc/autodl/run/$tag"`"
200 echo "sending SIGUSR1 to $pid"
203 echo "could not find pid for $tag"
206 if [ -e "$d/.autodl/restart" ]; then
207 echo "restarting $tag per user request"
208 rm -f "$d/.autodl/restart"
209 if [ -r "$HOME/dc/autodl/run/$tag" ]; then
210 pid="`cat "$HOME/dc/autodl/run/$tag"`"
211 echo "sending SIGUSR1 to $pid"
213 while [ -e "$HOME/dc/autodl/run/$tag" ]; do
214 echo "waiting for it to exit"
218 echo "could not find pid for $tag"
221 if [ $start = y ]; then
222 if [ ! -r "$d/.autodl/sexpr" ]; then
223 touch "$d/.autodl/disabled"
224 echo "$tag lacks sexpr" >&2
225 echo "$tag" >>"$HOME/dc/autodl/faulty"
227 if [ ! -e "$HOME/dc/autodl/run/$tag" ]; then
228 if [ $((`date +%s` - $lastget)) -gt 20 ]; then
229 getnext "$d" "$tag" &
232 echo "$pid" >"$HOME/dc/autodl/run/$tag"
243 for pidfile in $HOME/dc/autodl/run/*; do
244 if [ "$pidfile" = "$HOME/dc/autodl/run/*" ]; then break; fi
245 if [ "$(basename "$pidfile")" = master ]; then continue; fi
246 pid="`cat "$pidfile"`"
247 echo "sending SIGUSR1 to $pid for `basename "$pidfile"`"
251 rm -f "$HOME/dc/autodl/run/master"